import { ItemLikeProps } from "../collection-utils";
import { AnyPlasmicClass, PlasmicClassArgs, PlasmicClassOverrides, PlasmicClassVariants, VariantDef } from "../plume-utils";
export interface BaseMenuItemProps extends ItemLikeProps {
    /**
     * Called when this item is selected
     */
    onAction?: (key: string) => void;
}
interface MenuItemConfig<C extends AnyPlasmicClass> {
    isDisabledVariant?: VariantDef<PlasmicClassVariants<C>>;
    isHighlightedVariant?: VariantDef<PlasmicClassVariants<C>>;
    labelSlot: keyof PlasmicClassArgs<C>;
    root: keyof PlasmicClassOverrides<C>;
    labelContainer: keyof PlasmicClassOverrides<C>;
}
export declare function useMenuItem<P extends BaseMenuItemProps, C extends AnyPlasmicClass>(plasmicClass: C, props: P, config: MenuItemConfig<C>): {
    plasmicProps: {
        variants: PlasmicClassVariants<C>;
        args: PlasmicClassArgs<C>;
        overrides: PlasmicClassOverrides<C>;
    };
};
export {};
