import { PlasmicDataSourceContextValue } from "@plasmicapp/data-sources-context";
import { PlasmicI18NContextValue, PlasmicTranslator } from "@plasmicapp/host";
import { useIsSSR as useAriaIsSSR } from "@react-aria/ssr";
import * as React from "react";
export { PlasmicDataSourceContextProvider, useCurrentUser, } from "@plasmicapp/data-sources-context";
export interface PlasmicRootContextValue {
    platform?: "nextjs" | "gatsby";
}
export interface PlasmicRootProviderProps extends PlasmicDataSourceContextValue {
    platform?: "nextjs" | "gatsby";
    children?: React.ReactNode;
    i18n?: PlasmicI18NContextValue;
    /**
     * @deprecated use i18n.translator instead
     */
    translator?: PlasmicTranslator;
    Head?: React.ComponentType<any>;
    Link?: React.ComponentType<any>;
    disableLoadingBoundary?: boolean;
    suspenseFallback?: React.ReactNode;
}
export declare function PlasmicRootProvider(props: PlasmicRootProviderProps): React.JSX.Element;
export declare const useIsSSR: typeof useAriaIsSSR;
export declare function useHasPlasmicRoot(): boolean;
/**
 * Warns the user if PlasmicRootProvider is not used
 */
export declare function useEnsureSSRProvider(): void;
