'use strict';

var nextjsAppRouter = require('@plasmicapp/nextjs-app-router');
var reactServer = require('@plasmicapp/nextjs-app-router/react-server');
var query = require('@plasmicapp/query');
var React = require('react');

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise, SuppressedError, Symbol, Iterator */


function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

/**
 * Helper function to extract Plasmic data.
 *
 * Given React element for your page and current pathname + search
 * params, returns:
 * - The extracted query data, if `plasmicSsr` search param is set
 * - A copy of the page element wraped within PlasmicQueryDataProvider to provide the extracted query data, otherwise
 */
function __EXPERMIENTAL__withExtractPlasmicQueryData(pageRootElt, _a) {
    var _b, _c, _d;
    var pathname = _a.pathname, searchParams = _a.searchParams;
    return __awaiter(this, void 0, void 0, function () {
        var isPlasmicSsr, prepassHost, newSearchParams, prefetchedQueryData;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    isPlasmicSsr = !!(searchParams === null || searchParams === void 0 ? void 0 : searchParams["plasmicSsr"]) && (searchParams === null || searchParams === void 0 ? void 0 : searchParams["plasmicSsr"]) !== "false";
                    // If `plasmicSsr` search param is set, just wrap the page inside
                    // <ExtractPlasmicQueryData>
                    if (isPlasmicSsr) {
                        return [2 /*return*/, React.createElement(nextjsAppRouter.ExtractPlasmicQueryData, null, pageRootElt)];
                    }
                    prepassHost = (_c = (_b = process.env.PLASMIC_PREPASS_HOST) !== null && _b !== void 0 ? _b : (process.env.VERCEL_URL && "https://".concat(process.env.VERCEL_URL))) !== null && _c !== void 0 ? _c : "http://localhost:".concat((_d = process.env.PORT) !== null && _d !== void 0 ? _d : 3000);
                    newSearchParams = new URLSearchParams(Object.entries(searchParams !== null && searchParams !== void 0 ? searchParams : {}).flatMap(function (_a) {
                        var _b = __read(_a, 2), key = _b[0], values = _b[1];
                        return Array.isArray(values) ? values.map(function (v) { return [key, v]; }) : [[key, values]];
                    }));
                    // Set `plasmicSsr` search param to indicate you are using this endpoint
                    // to extract query data.
                    newSearchParams.set("plasmicSsr", "true");
                    if (process.env.VERCEL_AUTOMATION_BYPASS_SECRET) {
                        // If protection bypass is enabled, use it to ensure fetching from
                        // the SSR endpoint will not return the authentication page HTML
                        newSearchParams.set("x-vercel-protection-bypass", process.env.VERCEL_AUTOMATION_BYPASS_SECRET);
                    }
                    return [4 /*yield*/, reactServer.fetchExtractedQueryData("".concat(prepassHost).concat(pathname, "?").concat(newSearchParams.toString()))];
                case 1:
                    prefetchedQueryData = _e.sent();
                    // Provide the query data to your page
                    return [2 /*return*/, (React.createElement(query.PlasmicQueryDataProvider, { prefetchedCache: prefetchedQueryData }, pageRootElt))];
            }
        });
    });
}

Object.defineProperty(exports, '__EXPERMIENTAL__fetchExtractedHeadMetadata', {
    enumerable: true,
    get: function () { return reactServer.fetchExtractedHeadMetadata; }
});
Object.defineProperty(exports, '__EXPERMIENTAL__fetchExtractedQueryData', {
    enumerable: true,
    get: function () { return reactServer.fetchExtractedQueryData; }
});
Object.defineProperty(exports, '__EXPERMIENTAL__withPlasmicMetadata', {
    enumerable: true,
    get: function () { return reactServer.withPlasmicMetadata; }
});
exports.__EXPERMIENTAL__withExtractPlasmicQueryData = __EXPERMIENTAL__withExtractPlasmicQueryData;
//# sourceMappingURL=index.cjs.js.map
