import { PressResult } from "@react-aria/interactions";
import { MenuTriggerState } from "@react-stately/menu";
import { Placement } from "@react-types/overlays";
import * as React from "react";
import { BaseMenuProps } from "../menu/menu";
import { TriggeredOverlayContextValue } from "../triggered-overlay/context";
/**
 * A menu trigger hook that combines react-aria's useMenuTrigger, useAriaMenuTrigger,
 * useOverlayPosition, useOverlay, and usePress
 */
export declare function useMenuTrigger(opts: {
    isDisabled?: boolean;
    triggerRef: React.RefObject<HTMLElement>;
    placement?: Placement;
    menuMatchTriggerWidth?: boolean;
    menuWidth?: number;
    menu: React.ReactElement<BaseMenuProps> | (() => React.ReactElement<BaseMenuProps>);
}, state: MenuTriggerState): {
    triggerProps: PressResult["pressProps"];
    makeMenu: () => React.ReactElement;
    triggerContext: TriggeredOverlayContextValue;
};
