import { SectionLikeProps } from "../collection-utils";
import { AnyPlasmicClass, PlasmicClassArgs, PlasmicClassOverrides, PlasmicClassVariants } from "../plume-utils";
import { StyleProps } from "../props-utils";
export interface BaseMenuGroupProps extends SectionLikeProps, StyleProps {
}
interface MenuGroupConfig<C extends AnyPlasmicClass> {
    noTitleVariant: PlasmicClassVariants<C>;
    isFirstVariant: PlasmicClassVariants<C>;
    itemsSlot: keyof PlasmicClassArgs<C>;
    titleSlot: keyof PlasmicClassArgs<C>;
    root: keyof PlasmicClassOverrides<C>;
    separator: keyof PlasmicClassOverrides<C>;
    titleContainer: keyof PlasmicClassOverrides<C>;
    itemsContainer: keyof PlasmicClassOverrides<C>;
}
export declare function useMenuGroup<P extends BaseMenuGroupProps, C extends AnyPlasmicClass>(plasmicClass: C, props: P, config: MenuGroupConfig<C>): {
    plasmicProps: {
        variants: PlasmicClassVariants<C>;
        args: PlasmicClassArgs<C>;
        overrides: PlasmicClassOverrides<C>;
    };
};
export {};
