import * as React from "react";
import { AnyPlasmicClass, PlasmicClassArgs, PlasmicClassOverrides, PlasmicClassVariants } from "./plume-utils";
export interface StyleProps {
    className?: string;
    style?: React.CSSProperties;
}
export declare function getStyleProps<P extends StyleProps>(props: P): StyleProps;
export declare function getDefaultPlasmicProps<C extends AnyPlasmicClass>(plasmicClass: C, props: Record<string, any>): {
    plasmicProps: {
        variants: PlasmicClassVariants<C>;
        args: PlasmicClassArgs<C>;
        overrides: PlasmicClassOverrides<C>;
    };
};
export declare function getDataProps(props: Record<string, any>): Partial<Record<string, any>>;
