import { SectionLikeProps } from "../collection-utils";
import { AnyPlasmicClass, PlasmicClassArgs, PlasmicClassOverrides, PlasmicClassVariants, VariantDef } from "../plume-utils";
import { StyleProps } from "../props-utils";
export interface BaseSelectOptionGroupProps extends SectionLikeProps, StyleProps {
}
interface SelectOptionGroupConfig<C extends AnyPlasmicClass> {
    noTitleVariant: VariantDef<PlasmicClassVariants<C>>;
    isFirstVariant: VariantDef<PlasmicClassVariants<C>>;
    optionsSlot: keyof PlasmicClassArgs<C>;
    titleSlot: keyof PlasmicClassArgs<C>;
    root: keyof PlasmicClassOverrides<C>;
    separator: keyof PlasmicClassOverrides<C>;
    titleContainer: keyof PlasmicClassOverrides<C>;
    optionsContainer: keyof PlasmicClassOverrides<C>;
}
export declare function useSelectOptionGroup<P extends BaseSelectOptionGroupProps, C extends AnyPlasmicClass>(plasmicClass: C, props: P, config: SelectOptionGroupConfig<C>): {
    plasmicProps: {
        variants: PlasmicClassVariants<C>;
        args: PlasmicClassArgs<C>;
        overrides: PlasmicClassOverrides<C>;
    };
};
export {};
